root/HelpIM3_chi/helpim_init.d

Revision 692, 4.2 kB (checked in by winfried, 2 years ago)

- several fixes / improvements to webchat:

  • close button acts properly
  • improvements in closing chat
  • using new and optimised version of JSJaC

- Improvements in documentation
- improvements in varous scripts

  • Property svn:executable set to *
Line 
1#! /bin/sh
2### BEGIN INIT INFO
3# Provides:          helpim
4# Required-Start:    $remote_fs $network $tigase
5# Required-Stop:     $remote_fs $network $tigase
6# Default-Start:     2 3 4 5
7# Default-Stop:      0 1 6
8# Short-Description: HelpIM bot
9# Description:       Chatbot for administering, securing and logging chatrooms
10#                    for HelpIM. HelpIM is a highly configurable application
11#                    for psycho-social aid by instant messaging.
12### END INIT INFO
13
14# Author: Winfried Tilanus <winfried@tilanus.com>
15# Do NOT "set -e"
16
17# PATH should only include /usr/* if it runs after the mountnfs.sh script
18PATH=/sbin:/usr/sbin:/bin:/usr/bin
19DESC="HelpIM chatbot"
20NAME=helpim
21DAEMON=/usr/local/bin/$NAME
22DAEMON_ARGS=""
23PIDFILE=/var/run/$NAME.pid
24SCRIPTNAME=/etc/init.d/$NAME
25HELPIMUSER=helpim
26
27# Exit if the package is not installed
28[ -x "$DAEMON" ] || exit 0
29
30# Read configuration variable file if it is present
31[ -r /etc/default/$NAME ] && . /etc/default/$NAME
32
33# Load the VERBOSE setting and other rcS variables
34. /lib/init/vars.sh
35
36# Define LSB log_* functions.
37# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
38. /lib/lsb/init-functions
39
40#
41# Function that starts the daemon/service
42#
43do_start()
44{
45        # Return
46        #   0 if daemon has been started
47        #   1 if daemon was already running
48        #   2 if daemon could not be started
49        start-stop-daemon --start --quiet --background --make-pidfile --pidfile $PIDFILE --chuid $HELPIMUSER --exec $DAEMON --test > /dev/null \
50                || return 1
51        start-stop-daemon --start --quiet --background --make-pidfile --pidfile $PIDFILE --chuid $HELPIMUSER --exec $DAEMON -- \
52                $DAEMON_ARGS \
53                || return 2
54        # Add code here, if necessary, that waits for the process to be ready
55        # to handle requests from services started subsequently which depend
56        # on this one.  As a last resort, sleep for some time.
57}
58
59#
60# Function that stops the daemon/service
61#
62do_stop()
63{
64        # Return
65        #   0 if daemon has been stopped
66        #   1 if daemon was already stopped
67        #   2 if daemon could not be stopped
68        #   other if a failure occurred
69        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
70        RETVAL="$?"
71        [ "$RETVAL" = 2 ] && return 2
72        # Wait for children to finish too if this is a daemon that forks
73        # and if the daemon is only ever run from this initscript.
74        # If the above conditions are not satisfied then add some other code
75        # that waits for the process to drop all resources that could be
76        # needed by services started subsequently.  A last resort is to
77        # sleep for some time.
78        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
79        [ "$?" = 2 ] && return 2
80        # Many daemons don't delete their pidfiles when they exit.
81        rm -f $PIDFILE
82        return "$RETVAL"
83}
84
85#
86# Function that sends a SIGHUP to the daemon/service
87#
88do_reload() {
89        #
90        # If the daemon can reload its configuration without
91        # restarting (for example, when it is sent a SIGHUP),
92        # then implement that here.
93        #
94        start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
95        return 0
96}
97
98case "$1" in
99  start)
100        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
101        do_start
102        case "$?" in
103                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
104                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
105        esac
106        ;;
107  stop)
108        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
109        do_stop
110        case "$?" in
111                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
112                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
113        esac
114        ;;
115  #reload|force-reload)
116        #
117        # If do_reload() is not implemented then leave this commented out
118        # and leave 'force-reload' as an alias for 'restart'.
119        #
120        #log_daemon_msg "Reloading $DESC" "$NAME"
121        #do_reload
122        #log_end_msg $?
123        #;;
124  restart|force-reload)
125        #
126        # If the "reload" option is implemented then remove the
127        # 'force-reload' alias
128        #
129        log_daemon_msg "Restarting $DESC" "$NAME"
130        do_stop
131        case "$?" in
132          0|1)
133                do_start
134                case "$?" in
135                        0) log_end_msg 0 ;;
136                        1) log_end_msg 1 ;; # Old process is still running
137                        *) log_end_msg 1 ;; # Failed to start
138                esac
139                ;;
140          *)
141                # Failed to stop
142                log_end_msg 1
143                ;;
144        esac
145        ;;
146  *)
147        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
148        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
149        exit 3
150        ;;
151esac
152
153:
Note: See TracBrowser for help on using the browser.